package com.ruoyi.service.impl;

import com.alibaba.fastjson2.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.domain.TestRecords;
import com.ruoyi.mapper.TestRecordsMapper;
import com.ruoyi.service.TestRecordsService;
import okhttp3.Request;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;


@Transactional
@Service
public class TestRecordsServiceImpl extends ServiceImpl<TestRecordsMapper, TestRecords> implements TestRecordsService {


    public void getValue() throws IOException {
        JSONObject jsonObject = getInverseParamByUrl("http://10.12.48.78:8090/DescribeProjectTestResult");
    }

//    public static void main(String[] args) throws IOException {
//        JSONObject jsonObject = getInverseParamByUrl("http://10.12.48.78:8090/DescribeProjectTestResult");
//
//        System.out.println("jsonObject = " + jsonObject);
//    }
    /**
     * 通过API获取反参
     * @param apiUrl
     * @return
     * @throws IOException
     */
    public static JSONObject getInverseParamByUrl(String apiUrl) throws IOException {
        // 调用请求
        URL url = new URL(apiUrl);
        HttpURLConnection connection = (HttpURLConnection) url.openConnection();
        connection.setRequestMethod("GET");

        BufferedReader reader = new BufferedReader(new InputStreamReader(connection.getInputStream()));
        StringBuilder response = new StringBuilder();
        String line;
        while ((line = reader.readLine()) != null) {
            response.append(line);
        }
        reader.close();
        // 解析成JSON对象
        String jsonResponseString = response.toString();
        JSONObject jsonObject = JSONObject.parseObject(jsonResponseString);
        return jsonObject;
    }

    public static void main(String[] args) throws UnsupportedEncodingException {

        // 创建一个Request对象
//        Request request = new Request();
//        request.setParam1("project_items;1");
//        request.setParam2("ALL");
//
//        // 将Request对象转换为JSON字符串
//        Gson gson = new GsonBuilder().create();
//        String jsonRequest = gson.toJson(request);

        try {
            String apiUrl = "http://10.12.48.78:8090/DescribeProjectTestResult"; // 第三方URL
            String param1 = "project_items;1";
            String param2 = "ALL";

            String postData = String.format("param1=%s&param2=%s",
                    URLEncoder.encode(param1, "UTF-8"),
                    URLEncoder.encode(param2, "UTF-8"));

            URL url = new URL(apiUrl);
            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setRequestMethod("POST");
            conn.setDoOutput(true);

            // 设置请求体
            DataOutputStream outputStream = new DataOutputStream(conn.getOutputStream());
            outputStream.writeBytes(postData);
            outputStream.flush();
            outputStream.close();

            int responseCode = conn.getResponseCode();
            if (responseCode == HttpURLConnection.HTTP_OK) {
                BufferedReader in = new BufferedReader(new InputStreamReader(conn.getInputStream()));
                String inputLine;
                StringBuilder response = new StringBuilder();

                while ((inputLine = in.readLine()) != null) {
                    response.append(inputLine);
                }
                in.close();

                String responseBody = response.toString();
                JSONObject jsonObject = JSONObject.parseObject(responseBody);
                System.out.println("Response body: " + responseBody);
                System.out.println("jsonObject = " + jsonObject);
            } else {
                System.out.println("Request failed. Response code: " + responseCode);
            }

            conn.disconnect();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

}


